﻿local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales

C["general"] = {
	["autoscale"] = true,                               -- mainly enabled for users that don't want to mess with the config file
	["uiscale"] = 0.71,                                 -- set your value (between 0.64 and 1) of your uiscale if autoscale is off
	["overridelowtohigh"] = true,                      -- override lower version to higher version on a lower reso.
	["multisampleprotect"] = true,                      -- i don't recommend this because of shitty border but, voila!
}

C["theme"] = {											-- main theme for the UI -- [- Valid commands for font flag: "THINOUTLINE" / "OUTLINE" / "THICKOUTLINE" / "MONOCHROME" -]
	["chatf"] = C["media"].font,						-- chat font type
	["chatfs"] = 12,									-- chat font size
	["chatff"] = "",									-- chat font flag
	
	["dataf"] = C["media"].datafont,					-- datatext font type
	["datafs"] = 15,									-- datatext font size
	["dataff"] = "OUTLINE",								-- datatext font flag
	
	["uff"] = C["media"].uffont,						-- unitframe font type
	["uffs"] = 14,										-- unitframe font size
	["ufff"] = "THINOUTLINE",							-- unitframe font flag
	
	["uif"] = C["media"].dmgfont,						-- other ui elements font type (like combo points)
	["uifs"] = 30,										-- other ui elements font size
	["uiff"] = "OUTLINE",								-- other ui elements font flag
	
	["pfont"] = false,									-- enables pixelfont for the entire UI
		["pfonts"] = 8,										-- pixelfont font size (8 for best look)
		["pfontf"] = "THINOUTLINE, MONOCHROME",				-- pixelfont font flag
		
	["shadow"] = true,									-- enable shadow texture around almost everything
}

C["unitframes"] = {
	-- general options
	["enable"] = true,                                  -- do i really need to explain this?
	["enemyhcolor"] = false,                            -- enemy target (players) color by hostility, very useful for healer.
	["unitcastbar"] = true,                             -- enable tukui castbar
		["cbcolor"]	= true,									-- enable class colored cast bars
		["cblatency"] = true,                              -- enable castbar latency
		["cbicons"] = true,                                 -- enable icons on castbar
		["cbinside"] = false,								-- enable castbars inside the unitframe (false to move it to the middle of the screen)
	["auratimer"] = true,                               -- enable timers on buffs/debuffs
	["auratextscale"] = 11,                             -- the font size of buffs/debuffs timers on unitframes
	["playerauras"] = false,                            -- enable auras for the player
	["targetauras"] = true,                             -- enable auras on target unit frame
	["lowThreshold"] = 20,                              -- global low threshold, for low mana warning.
	["targetpowerpvponly"] = true,                      -- enable power text on pvp target only
	["showfocustarget"] = true,           				-- show focus target	-- Not recommended, but a choice...
	["showtotalhpmp"] = false,                          -- change the display of info text on player and target with XXXX/Total.
	["showsmooth"] = true,                              -- enable smooth bar
	["charportrait"] = true,                           -- do i really need to explain this?
	["maintank"] = true,                               -- enable maintank
	["mainassist"] = false,                             -- enable mainassist
	["unicolor"] = true,                               -- enable unicolor theme
	["combatfeedback"] = true,                          -- enable combattext on player and target.
	["playeraggro"] = true,                             -- color player border to red if you have aggro on current target.
	["healcomm"] = true,                               -- enable healprediction support.
	["onlyselfdebuffs"] = false,                        -- display only our own debuffs applied on target
	
	-- custom config
	["classcolortheme"] = true, 						-- sets the border of the ui into class colored theme
	["percentage"] = true,            					-- shows a hp/pp percent number next to a unitframe on selected frames
	["swing"] = false,									-- enable a swing bar for the unitframes (located just above the middle datatext panel under the actionbars)
	["vengeance"] = true,								-- enable a vengeance plugin / Tanks ONLY (located on the middle datatext panel when gaining vengeance)
	--["absorb"] = true,									-- enables a custom made bar for different auras that arbsorbs damage (not working atm)

	["totdebuffs"] = true,                             -- enable tot debuffs (high reso only)
	["focusdebuffs"] = true,              				-- enable focus debuffs (high reso only)
	["petbuffs"] = true,                   				-- enable pet buffs (high reso only)

	-- raid layout (if one of them is enabled)
	["showrange"] = true,                               -- show range opacity on raidframes
	["raidalphaoor"] = 0.4,                             -- alpha of unitframes when unit is out of range
	["gridonly"] = true,                               -- enable grid only mode for all healer mode raid layout.
	["showsymbols"] = true,	                            -- show symbol.
	["aggro"] = true,                                   -- show aggro on all raids layouts
	["raidunitdebuffwatch"] = true,                     -- track important spell to watch in pve for grid mode.
	["gridhealthvertical"] = true,                      -- enable vertical grow on health bar for grid mode.
	["showplayerinparty"] = true,                      -- show my player frame in party. It is recommended to be turned on for optimal layout.
	["gridscale"] = 1,                                  -- set the healing grid scaling
	["raidtimer"] = false,								-- enable aura cooldown timer on raiddebuffs (heal layout only)
	
	-- boss frames
	["showboss"] = true,                                -- enable boss unit frames for PVELOL encounters.

	-- priest only plugin
	["weakenedsoulbar"] = true,                         -- show weakened soul bar
	
	-- class bar
	["classbar"] = true,                                -- enable tukui classbar over player unit
	["soulshardbar"] = true,							-- same classbar as above, just need a separate line to use if CCP is enabled
	["holypowerbar"] = true,							-- same as above
}

C["arena"] = {
	["unitframes"] = true,                              -- enable tukz arena unitframes (requirement : tukui unitframes enabled)
}

C["auras"] = {
	["player"] = true,                                  -- enable tukui buffs/debuffs
}

C["actionbar"] = {
	["enable"] = true,                                  -- enable tukui action bars
	["hotkey"] = true,                                 -- enable hotkey display because it was a lot requested
	["hideshapeshift"] = false,                         -- hide shapeshift or totembar because it was a lot requested.
	["showgrid"] = true,                                -- show grid on empty button
	["buttonsize"] = 30,                                -- normal buttons size
	["buttonspacing"] = 3,                              -- buttons spacing
}

C["bags"] = {
	["enable"] = true,                                  -- enable an all in one bag mod that fit tukui perfectly
}

C["map"] = {
	["enable"] = true,                                  -- reskin the map to fit tukui
}

C["loot"] = {
	["lootframe"] = true,                               -- reskin the loot frame to fit tukui
	["rolllootframe"] = true,                           -- reskin the roll frame to fit tukui
	["autogreed"] = true,                               -- auto-dez or auto-greed item at max level, auto-greed Chaos orb
}

C["cooldown"] = {
	["enable"] = true,                                  -- do i really need to explain this?
	["treshold"] = 5,                                   -- show decimal under X seconds and text turn red
}

C["timetodie"] = { 
	["enable"] = true,             						-- enables calculated time to die on your target
	["type"] = 2,                  						-- set your mobtype (1 = raidboss only) (2 = raidboss and playerlevel + 3 mobs (hc instance bosses, 83 mobs etc.)) (3 = show add for every mob available)
	["dps"] = false,                   					-- show raid dps?
	["length"] = false,                					-- show fight length?
}

C["datatext"] = {
	["system"] = 12,                                     -- show total memory, fps, latency and others systems infos on the panel
	["bags"] = 0,                                       -- show space used in bags on panels
	["gold"] = 5,                                       -- show your current gold on panels
	["wowtime"] = 10,                                    -- show time on panels
	["guild"] = 1,                                      -- show number on guildmate connected on panels
	["dur"] = 2,                                        -- show your equipment durability on panels.
	["friends"] = 3,                                    -- show number of friends connected.
	["dps_text"] = 0,                                   -- show a dps meter on panels
	["hps_text"] = 0,                                   -- show a heal meter on panels
	["power"] = 7,                                      -- show your attackpower/spellpower/healpower/rangedattackpower whatever stat is higher gets displayed
	["haste"] = 9,                                      -- show your haste rating
	["crit"] = 4,                                       -- show your crit percent
	["avd"] = 0,                                        -- show your current avoidance against the level of the mob your targeting
	["armor"] = 0,                                      -- show your armor value against the level mob you are currently targeting
	["currency"] = 0,                                   -- show your tracked currency on panels
	["hit"] = 0,										-- show your current hit
	["mastery"] = 6,									-- show your mastery rating
	["micromenu"] = 11,									-- show the micromenu
	["spec"] = 8,										-- show your current talent tree and spec

	["bars"] = true,									-- enable experience/reputation bars under the minimap
	["text"] = false, 									-- enable text on exp/rep bar
	["location"] = true,								-- enable location text and coords on the top of the screen
	
	["battleground"] = true,                            -- enable 3 stats in battleground only that replace stat1,stat2,stat3.
	["time24"] = true,                                  -- set time to 24h format.
	["localtime"] = true,                              -- set time to local time instead of server time.
	["classcolor"]	= true,								-- class colored text
		["color"] = { 1, 1, 1, 0.9 } 						-- R,G,B,A value if classcolor is false
}

C["chat"] = {
	["enable"] = true,                                  -- blah
	["whispersound"] = true,                            -- play a sound when receiving whisper
	["fading"] = false,									-- enable fading on chat
	["background"] = true,								-- chat background, what else?
	["chatheight"] = C["theme"].chatfs * 12,				-- the "chatfs * X" equals the size of the chatfont times the value.
}

C["nameplate"] = {
	["enable"] = true,                                  -- enable nice skinned nameplates that fit into tukui
	["showhealth"] = true,				                -- show health text on nameplate
	["enhancethreat"] = true,			                -- threat features based on if your a tank or not
	["combat"] = false,					                -- only show enemy nameplates in-combat.
	["goodcolor"] = {75/255,  175/255, 76/255},	        -- good threat color (tank shows this with threat, everyone else without)
	["badcolor"] = {0.78, 0.25, 0.25},			        -- bad threat color (opposite of above)
	["transitioncolor"] = {218/255, 197/255, 92/255},	-- threat color when gaining threat
}

C["tooltip"] = {
	["enable"] = true,                                  -- true to enable this mod, false to disable
	["hidecombat"] = false,                             -- hide bottom-right tooltip when in combat
	["hidebuttons"] = false,                            -- always hide action bar buttons tooltip.
	["hideuf"] = false,                                 -- hide tooltip on unitframes
	["cursor"] = false,                                 -- tooltip via cursor only
	["id"] = true,										-- enables spellid's on abilities and spells
}

C["merchant"] = {
	["sellgrays"] = true,                               -- automaticly sell grays?
	["autorepair"] = true,                              -- automaticly repair?
	["sellmisc"] = true,                                -- sell defined items automatically
}

C["error"] = {
	["enable"] = true,                                  -- true to enable this mod, false to disable
	filter = {                                          -- what messages to not hide
		[INVENTORY_FULL] = true,                        -- inventory is full will not be hidden by Dajova
	},
}

C["invite"] = { 
	["autoaccept"] = true,                              -- auto-accept invite from guildmate and friends.
}

C["buffreminder"] = {
	["enable"] = true,                                  -- this is now the new innerfire warning script for all armor/aspect class.
	["sound"] = false,                                   -- enable warning sound notification for reminder.
}

C["others"] = {
	["questannounce"] = true, 							-- moves the quest progress from error frame to raid warning, plus adds sounds on completing objectives and quests
	["autoquest"] = true,                 				-- enable auto-accept and auto turn-in of quests
	["viewport"] = true, 								-- adds a viewport on your screen.
	["gficon"] = false,									-- enable the ghost frame icon on the left side of the minimap. (Me personally dont like it, but adding a option anyway...)
}

--------------------------------------------------------------------------
--				!!	DO NOT EDIT ANYTHING BELOW	!!						--
--------------------------------------------------------------------------

-- class colored value for datatext
if C.datatext.classcolor == true then
	local classcolor = RAID_CLASS_COLORS[T.myclass]
	C.datatext.color = {classcolor.r,classcolor.g,classcolor.b,1}
end

-- convert datatext T.Color from rgb decimal to hex DO NOT TOUCH
local r, g, b = unpack(C["datatext"].color)
T.Color = ("|cff%.2x%.2x%.2x"):format(r * 255, g * 255, b * 255)