﻿local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales

--------------------------------------------------------------------------
-- Per Class Config (overwrite general)
-- Class need to be case sensitive
--------------------------------------------------------------------------

if T.myclass == "SHAMAN" then
	-- do some config!
end

if T.myclass == "ROGUE" then
	--C.combo.enable = false		-- testing purpose
end

--------------------------------------------------------------------------
-- Per Character Name Config (overwrites everything above)
-- Name need to be case sensitive
--------------------------------------------------------------------------

if T.myname == "Dajova" then
	-- do some config!
end

--------------------------------------------------------------------------
-- Per Role Config (overwrites everything above)
-- You want different settings depening on role.
--------------------------------------------------------------------------

if T.Role == "Melee" then
	-- do some config!
end

--------------------------------------------------------------------------
-- Per Level Config (overwrites everything above)
-- Sets the config depening on your current level.
--------------------------------------------------------------------------

-- Sets setting on characters less than lvl 10
if T.level < 10 then						-- srsly don't need a load of stuff when you just started playing >_<
	C.unitframes.percentage = false
	C.unitframes.swing = false
	C.unitframes.healcomm = false
	C.nameplate.showhealth = false
	C.nameplate.enhancethreat = false
	C.datatext.spec = 0
	C.datatext.currency = 8
	C.datatext.mastery = 0
	C.datatext.hit = 6
	C.datatext.text = true 
	C.datatext.text = true 
	C.timetodie.enable = false
	C.invite.autoaccept = false
end
-- Sets setting on characters equal or more than lvl 10 and less than lvl 20
if T.level >= 10 and T.level < 20 then
	C.unitframes.percentage = false
	C.unitframes.healcomm = false
	C.nameplate.showhealth = false
	C.datatext.mastery = 0
	C.datatext.hit = 6
	C.datatext.text = true 
	C.datatext.text = true 
	C.timetodie.enable = false
	C.invite.autoaccept = false
end
-- Sets setting on characters equal or more than lvl 20 and less than lvl 80
if T.level >= 20 and T.level < 80 then
	C.datatext.mastery = 0
	C.datatext.hit = 6
	C.datatext.text = true  
	C.invite.autoaccept = false
end
-- Sets setting on characters equal or more than lvl 80 and less than 85
if T.level >= 80 and T.level < 85 then
	C.datatext.text = true 
	C.invite.autoaccept = false
end

--------------------------------------------------------------------------
-- Per Addon Config (overwrites everything above)
-- Name need to be case sensitive.
-- PS: Need to be added to optional deps (in the TOC) to work.
--------------------------------------------------------------------------

if IsAddOnLoaded("Minimalist") then		-- using my own profile when raiding
	C.loot.autogreed = false
	C.merchant.sellgrays = false
	C.merchant.autorepair = false
	C.others.autoquest = false
end

--------------------------------------------------------------------------
-- Per Client Config (overwrites everything above)
-- Some clients are just... meh :P
--------------------------------------------------------------------------

if T.client == "enUS" then
--	C.datatext.time24 = false		-- adding just in case =x
end

--------------------------------------------------------------------------
-- Special Case Config (overwrites everything above)
-- Here goes everything if you wanna combind configs (see examples below)
--------------------------------------------------------------------------

if T.myclass == "SHAMAN" and T.myname == "Dajova" then
	C.nameplate.showhealth = false
	C.chat.fading = true
	C.timetodie.type = 3
	C.unitframes.classbar = false
	--C.theme.pfont = true		-- testing purpose
end

------------------------------------------------------------------------------
-- 			Special addon support for different Tukui-only mods.			--
------------------------------------------------------------------------------

-- Workaround to disable the combo module automaticly if either sCombo or fComboBar is loaded
local Combo = CreateFrame("Frame")
Combo:RegisterEvent("ADDON_LOADED")
Combo:SetScript("OnEvent", function(self, event, addon)
	if addon == "sCombo" or addon == "fComboBar" then
		-- first my combo module
		CCP:UnregisterEvent("PLAYER_ENTERING_WORLD")
		CCP:UnregisterEvent("PLAYER_TARGET_CHANGED")
		CCP:UnregisterEvent("UNIT_COMBO_POINTS")
		CCP:UnregisterEvent("UNIT_EXITED_VEHICLE")
		-- second tukui default combo
		if not addon == "sCombo" then
			TukuiTarget:DisableElement('CPoints') 
			for i = 1, 5 do 
				TukuiTarget.CPoints[i]:Hide()
				if TukuiTarget.cB[i] then
					TukuiTarget.cB[i]:Hide()
				end
			end
		end
	else
		return
	end
	
	self:UnregisterEvent("ADDON_LOADED")
end)