local T, C, L = unpack(select(2, ...))

local function SkinIt(bar)	
	local _, originalPoint, _, _, _ = bar:GetPoint()
	
	local font, fonts, fontf

	if C["theme"].pfont then
		font, fonts, fontf = C["media"].pixelfont, C["theme"].pfonts, C["theme"].pfontf
	else
		font, fonts, fontf = C["theme"].uff, C["theme"].uffs + 2, C["theme"].ufff
	end
	
	bar:ClearAllPoints()
	bar:Point("TOPLEFT", originalPoint, "TOPLEFT", 4, -4)
	bar:Point("BOTTOMRIGHT", originalPoint, "BOTTOMRIGHT", -4, 4)
		
	for i=1, bar:GetNumRegions() do
		local region = select(i, bar:GetRegions())
		if region:GetObjectType() == "Texture" then
			region:SetTexture(nil)
		elseif region:GetObjectType() == "FontString" then
			region:SetFont(font, fonts, fontf)
			region:SetShadowColor(0,0,0,0)
		end
	end
	
	bar:SetStatusBarTexture(C["media"].normTex)
	bar:SetStatusBarColor(unpack(C["media"].bgcolor))
	
	bar.backdrop = CreateFrame("Frame", nil, bar)
	bar.backdrop:SetFrameLevel(0)
	bar.backdrop:SetTemplate("Default", true)
	bar.backdrop:CreateShadow("Default")
	bar.backdrop:Point("TOPLEFT", bar, "TOPLEFT", -2, 2)
	bar.backdrop:Point("BOTTOMRIGHT", bar, "BOTTOMRIGHT", 2, -2)
end

local function SkinBlizzTimer(self, event)
	for _, b in pairs(TimerTracker.timerList) do
		if not b["bar"].skinned then
			SkinIt(b["bar"])
			b["bar"].skinned = true
		end
	end
end

local load = CreateFrame("Frame")
load:RegisterEvent("START_TIMER")
load:SetScript("OnEvent", SkinBlizzTimer)