local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales
-- m_CombatText by Monolit, edited by Dajova for Tukui
if not IsAddOnLoaded("MikScrollingBattleText") then 
	if not IsAddOnLoaded("Blizzard_CombatText") then 
		UIParentLoadAddOn("Blizzard_CombatText") 
	end 
	
	SetCVar("CombatDamage", 1)
	SetCVar("CombatHealing", 1)
	SetCVar("enableCombatText", 1) 
	
	if T.myclass == "PRIEST" then
		local sp = CreateFrame("Frame")
		local function spOnEvent(...)
			if(GetShapeshiftForm()==1)then
				SetCVar('CombatHealing',0)
			else
				SetCVar('CombatHealing',1)
			end
		end	
		sp:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		sp:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
		sp:SetScript("OnEvent",spOnEvent)
	end
else
	SetCVar("CombatDamage", 0)
	SetCVar("CombatHealing", 0)
	SetCVar("enableCombatText", 0)
	return
end

function mct()
	-- set the unit to track 
	if ( UnitHasVehicleUI("player") ) then 
	    CombatText.unit = "vehicle"; 
	else 
	    CombatText.unit = "player"; 
	end 
	CombatTextSetActiveUnit(CombatText.unit); 
	 
	-- register events 
	CombatText:RegisterEvent("COMBAT_TEXT_UPDATE")
	CombatText:RegisterEvent("UNIT_HEALTH")
	CombatText:RegisterEvent("UNIT_POWER")
	CombatText:RegisterEvent("PLAYER_REGEN_DISABLED")
	CombatText:RegisterEvent("PLAYER_REGEN_ENABLED")
	CombatText:RegisterEvent("PLAYER_COMBO_POINTS")
	CombatText:RegisterEvent("UNIT_ENTERED_VEHICLE")
	CombatText:RegisterEvent("UNIT_EXITING_VEHICLE")
	   
	-- look'n'feel
	COMBAT_TEXT_SCROLLSPEED = 3
	COMBAT_TEXT_FADEOUT_TIME = 1.5
	
	COMBAT_TEXT_DEFLECT = "Deflect"
    COMBAT_TEXT_REFLECT = "Reflect"
    COMBAT_TEXT_IMMUNE = "Immune"
    COMBAT_TEXT_RESIST = "Resist"
    COMBAT_TEXT_ABSORB = "Absorb"
    COMBAT_TEXT_BLOCK = "Block"
    COMBAT_TEXT_DODGE = "Dodge"
    COMBAT_TEXT_PARRY = "Parry"
    COMBAT_TEXT_EVADE = "Evade"
    COMBAT_TEXT_MISS = "Miss"
        
    DEFLECT = "Deflect"
    REFLECT = "Reflect"
    IMMUNE = "Immune"
    RESIST = "Resist"
    ABSORB = "Absorb"
    BLOCK = "Block"
    DODGE = "Dodge"
    PARRY = "Parry"
    EVADE = "Evade"
    MISS = "Miss"
        
    ENTERING_COMBAT = "++ COMBAT ++"
    LEAVING_COMBAT = "-- COMBAT --"
	 
	-- Get scale 
	COMBAT_TEXT_Y_SCALE = WorldFrame:GetHeight() / 768
	COMBAT_TEXT_X_SCALE = WorldFrame:GetWidth() / 1024
	COMBAT_TEXT_SPACING = 10 * COMBAT_TEXT_Y_SCALE
	COMBAT_TEXT_MAX_OFFSET = 100 * COMBAT_TEXT_Y_SCALE
	COMBAT_TEXT_X_ADJUSTMENT = 60 * COMBAT_TEXT_X_SCALE

	COMBAT_TEXT_SCROLL_FUNCTION = CombatText_StandardScroll
	COMBAT_TEXT_LOCATIONS = { 
	    startX = 400, 
	    startY = 700 * COMBAT_TEXT_Y_SCALE, 
	    endX = 400, 
	    endY = 500 * COMBAT_TEXT_Y_SCALE 
	    }; 
	CombatText_ClearAnimationList()
end

CombatText_UpdateDisplayedMessages = mct