local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales

local height = T.buttonsize - 10

-- INFO LEFT (FOR STATS)
local ileft = CreateFrame("Frame", "TukuiInfoLeft", UIParent)

-- INFO RIGHT (FOR STATS)
local iright = CreateFrame("Frame", "TukuiInfoRight", UIParent)

-- INFO TOPLEFT (FOR STATS)
local itop = CreateFrame("Frame", "TukuiInfoTop", UIParent)

if C["others"].viewport then
	ileft:CreatePanel("Disable", false, T.DataWidth, height, "BOTTOMLEFT", UIParent, "BOTTOMLEFT", 4, -2)
	ileft:SetFrameLevel(0)
		
	iright:CreatePanel("Disable", false, T.DataWidth, height, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -4, -2)
	iright:SetFrameLevel(0)
	
	itop:CreatePanel("Disable", false, T.DataWidth, height, "TOPLEFT", UIParent, "TOPLEFT", 2, 2)
	itop:SetFrameLevel(0)
else
	ileft:CreatePanel("Default", true, T.DataWidth - 12, height, "BOTTOMLEFT", UIParent, "BOTTOMLEFT", 10, 10)
	ileft:SetFrameLevel(2)

	iright:CreatePanel("Default", true, T.DataWidth - 12, height, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -10, 10)
	iright:SetFrameLevel(2)
	
	itop:CreatePanel("Default", true, T.DataWidth - T.buttonspacing, height, "TOPLEFT", UIParent, "TOPLEFT", 5, -10)
	itop:SetFrameLevel(2)
	
	-- INFO BOTTOM (FOR STATS)
	local ibottom = CreateFrame("Frame", "TukuiInfoBottom", UIParent)
	ibottom:CreatePanel("Default", true, T.DataWidth, height, "BOTTOM", UIParent, "BOTTOM", 0, 10)
	ibottom:SetFrameLevel(2)
end

if C.chat.background then
	-- CHAT BG LEFT
	local chatleftbg = CreateFrame("Frame", "TukuiChatBackgroundLeft", TukuiInfoLeft)
	chatleftbg:CreatePanel("Transparent", false, T.DataWidth, (C["chat"].chatheight + (height * 3)), "BOTTOM", TukuiInfoLeft, "BOTTOM", 0, -8)

	-- CHAT BG RIGHT
	local chatrightbg = CreateFrame("Frame", "TukuiChatBackgroundRight", TukuiInfoRight)
	chatrightbg:CreatePanel("Transparent", false, T.DataWidth, (C["chat"].chatheight + (height * 3)), "BOTTOM", TukuiInfoRight, "BOTTOM", 0, -8)
	
	-- LEFT TAB PANEL
	local tabsbgleft = CreateFrame("Frame", "TukuiTabsLeftBackground", chatleftbg)
	tabsbgleft:CreatePanel("Default", true, T.DataWidth - 12, height, "TOP", chatleftbg, "TOP", 0, -5)
	tabsbgleft:SetFrameLevel(2)
		
	-- RIGHT TAB PANEL
	local tabsbgright = CreateFrame("Frame", "TukuiTabsRightBackground", chatrightbg)
	tabsbgright:CreatePanel("Default", true, T.DataWidth - 12, height, "TOP", chatrightbg, "TOP", 0, -5)
	tabsbgright:SetFrameLevel(2)
end

-- VIEWPORT ON TOP AND BOTTOM OF THE UI
if C["others"].viewport then
	local tbar = CreateFrame("Frame", "TukuiTopBar", UIParent)
	tbar:CreatePanel("Default", true, 1, 1, "TOP", UIParent, "TOP", 0, 2)
	tbar:SetWidth(T.getscreenwidth + 4)
	tbar:SetHeight(height+2)
	tbar:SetFrameStrata("BACKGROUND")
	tbar:SetFrameLevel(4)
		
	local bbar = CreateFrame("Frame", "TukuiBottomBar", UIParent)
	bbar:CreatePanel("Default", true, 1, 1, "BOTTOM", UIParent, "BOTTOM", 0, -2)
	bbar:SetWidth(T.getscreenwidth + 4)
	bbar:SetHeight(height+2)
	bbar:SetFrameStrata("BACKGROUND")
	bbar:SetFrameLevel(3)
end

if C.actionbar.enable then
	local TukuiBar1
	local TukuiBar2 = CreateFrame("Frame", "TukuiBar2", UIParent)
	
	if C["others"].viewport then
		TukuiBar1 = CreateFrame("Frame", "TukuiBar1", TukuiBottomBar, "SecureHandlerStateTemplate")
		TukuiBar1:Point("BOTTOM", TukuiBottomBar, "TOP", -3, 3)
		TukuiBar2:Point("BOTTOM", TukuiBottomBar, "TOP", -3, 3)
	else
		TukuiBar1 = CreateFrame("Frame", "TukuiBar1", TukuiInfoBottom, "SecureHandlerStateTemplate")
		TukuiBar1:Point("BOTTOM", TukuiInfoBottom, "TOP", -3, 3)
		TukuiBar2:Point("BOTTOM", TukuiInfoBottom, "TOP", -3, 3)
	end
	
	TukuiBar1:SetWidth(T.DataWidth)
	TukuiBar1:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
	TukuiBar1:SetFrameStrata("BACKGROUND")
	TukuiBar1:SetFrameLevel(1)
		
	TukuiBar2:SetWidth(T.DataWidth)
	TukuiBar2:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
	TukuiBar2:SetFrameStrata("BACKGROUND")
	TukuiBar2:SetFrameLevel(2)

	local TukuiBar3 = CreateFrame("Frame", "TukuiBar3", UIParent)
	TukuiBar3:SetWidth((T.DataWidth / 2) + T.buttonspacing)
	TukuiBar3:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
	TukuiBar3:SetPoint("BOTTOMLEFT", TukuiBar1, "BOTTOMRIGHT", T.Scale(4), 0)
	TukuiBar3:SetFrameStrata("BACKGROUND")
	TukuiBar3:SetFrameLevel(2)
	if T.lowversion then
		TukuiBar3:SetAlpha(0)
	else
		TukuiBar3:SetAlpha(1)
	end

	local TukuiBar4 = CreateFrame("Frame", "TukuiBar4", UIParent)
	TukuiBar4:SetWidth((T.DataWidth / 2) + T.buttonspacing)
	TukuiBar4:SetHeight((T.buttonsize * 2) + (T.buttonspacing * 3))
	TukuiBar4:SetPoint("BOTTOMRIGHT", TukuiBar1, "BOTTOMLEFT", 0, 0)
	TukuiBar4:SetFrameStrata("BACKGROUND")
	TukuiBar4:SetFrameLevel(2)
	if T.lowversion then
		TukuiBar4:SetAlpha(0)
	else
		TukuiBar4:SetAlpha(1)
	end

	local TukuiBar5 = CreateFrame("Frame", "TukuiBar5", TukuiChatBackgroundRight)
	TukuiBar5:SetWidth(T.DataWidth + 2)
	TukuiBar5:SetHeight(T.buttonsize + (T.buttonspacing * 2))
	TukuiBar5:Point("BOTTOM", TukuiChatBackgroundRight, "TOP", -2, 0)
	TukuiBar5:SetFrameStrata("BACKGROUND")
	TukuiBar5:SetFrameLevel(2)

	local TukuiBar6 = CreateFrame("Frame", "TukuiBar6", TukuiChatBackgroundRight)
	TukuiBar6:SetWidth(T.DataWidth + 2)
	TukuiBar6:SetHeight(T.buttonsize + (T.buttonspacing * 2))
	TukuiBar6:SetPoint("BOTTOM", TukuiChatBackgroundRight, "TOP", 0, T.buttonspacing)
	TukuiBar6:SetFrameStrata("BACKGROUND")
	TukuiBar6:SetFrameLevel(2)
	TukuiBar6:SetAlpha(0)

	local TukuiBar7 = CreateFrame("Frame", "TukuiBar7", TukuiChatBackgroundRight)
	TukuiBar7:SetWidth(T.DataWidth + 2)
	TukuiBar7:SetHeight(T.buttonsize + (T.buttonspacing * 2))
	TukuiBar7:SetPoint("BOTTOM", TukuiChatBackgroundRight, "TOP", 0, T.buttonspacing)
	TukuiBar7:SetFrameStrata("BACKGROUND")
	TukuiBar7:SetFrameLevel(2)
	TukuiBar7:SetAlpha(0)

	local petbg = CreateFrame("Frame", "TukuiPetBar", UIParent, "SecureHandlerStateTemplate")
	petbg:SetWidth(T.DataWidth - ((T.buttonsize * 2) + (T.buttonspacing * 3)))
	petbg:SetHeight(T.buttonsize + (T.buttonspacing * 2))
	petbg:SetPoint("BOTTOM", TukuiBar1, "TOP", T.Scale(-2), -T.buttonspacing)
	petbg:SetFrameStrata("BACKGROUND")
	petbg:SetFrameLevel(2)
end

-- CUBE AT LEFT, ACT AS A BUTTON (CHAT MENU)
local cubeleft = CreateFrame("Frame", "TukuiCubeLeft", TukuiBar1)
cubeleft:CreatePanel("Default", true, height/2, height, "LEFT", ibottom, "RIGHT", T.buttonspacing, 0)
cubeleft:EnableMouse(true)
cubeleft:SetScript("OnMouseDown", function(self, btn)
	if TukuiInfoLeftBattleGround and UnitInBattleground("player") then
		if btn == "RightButton" then
			if TukuiInfoLeftBattleGround:IsShown() then
				TukuiInfoLeftBattleGround:Hide()
			else
				TukuiInfoLeftBattleGround:Show()
			end
		end
	end
	if btn == "LeftButton" then	
		ToggleFrame(ChatMenu)
	end
end)

-- CUBE AT RIGHT, ACT AS A BUTTON (CONFIGUI or BG'S)
local cuberight = CreateFrame("Frame", "TukuiCubeRight", TukuiBar1)
cuberight:CreatePanel("Default", true, height/2, height, "RIGHT", ibottom, "LEFT", -T.buttonspacing, 0)
if C["bags"].enable then
	cuberight:EnableMouse(true)
	cuberight:SetScript("OnMouseDown", function(self)
		ToggleKeyRing()
	end)
end

--BATTLEGROUND STATS FRAME
if C["datatext"].battleground == true then
	local bgframe = CreateFrame("Frame", "TukuiInfoLeftBattleGround", UIParent)
	bgframe:CreatePanel("Default", true, 1, 1, "TOPLEFT", UIParent, "BOTTOMLEFT", 0, 0)
	bgframe:SetAllPoints(ileft)
	bgframe:SetFrameStrata("LOW")
	bgframe:SetFrameLevel(0)
	bgframe:EnableMouse(true)
end