local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales

local TelUI_AddonSkins = CreateFrame("Frame")
TelUI_AddonSkins:RegisterEvent("ADDON_LOADED")
TelUI_AddonSkins:SetScript("OnEvent", function(self, event, addon)
	if not addon == "TelUI_AddonSkins" then return end

	CustomSkin = { }
	
	CustomSkin.normTexture = C["media"].normTex
	CustomSkin.bgTexture = C["media"].overTex
	CustomSkin.font = C["theme"].chatf
	CustomSkin.fontSize = C["theme"].chatfs
	CustomSkin.fontFlags = C["theme"].chatff
	CustomSkin.buttonSize = T.buttonsize
	CustomSkin.buttonSpacing = T.buttonspacing
	CustomSkin.borderWidth = T.Scale(2)
	CustomSkin.buttonZoom = { .08, .92, .08, .92 }
	CustomSkin.barSpacing = 1
	CustomSkin.barHeight = T.buttonsize - 10
	
	function CustomSkin:SkinBackgroundFrame(frame)
		self:SkinFrame(frame)
		frame:SetTemplate("Transparent", true)
		frame:CreateShadow("Default")
	end
	
	function CustomSkin:SkinButton(button)
		self:SkinFrame(button)
		button:StyleButton(button.GetCheckedTexture and button:GetCheckedTexture())
	end

	self:UnregisterEvent("ADDON_LOADED")
end)