local T, C, L = unpack(select(2, ...)) -- Import: T - functions, constants, variables; C - config; L - locales
-- Editless skin by Dajova
if not (IsAddOnLoaded("TinyDPS")) then return end

local TinyDPS = CreateFrame("Frame")
TinyDPS:RegisterEvent('ADDON_LOADED')
TinyDPS:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
TinyDPS:SetScript("OnEvent", function(self, event)
	if not addon == "TinyDPS" then return end
	
	local font, fonts, fontf

	if C["theme"].pfont then
		font, fonts, fontf = C["media"].pixelfont, C["theme"].pfonts, 'Outlinemonochrome'
	else
		font, fonts, fontf = C["theme"].dataf, C["theme"].datafs - 2, 'Outline'
	end
	
	-- makes a error if we try to start up without a saved file
	if tdps then
		tdps.width = TukuiMinimap:GetWidth()
		tdps.spacing = T.Scale(1)
		tdps.barHeight = T.buttonsize - 14
		tdps.onlyBossSegments = true
		tdps.trackSpells = true
		tdps.hidePvP = true
		
		tdpsFont.name = font
		tdpsFont.size = fonts
		tdpsFont.outline = fontf
		
		tdpsReportLength = 5
		tdpsV = "d"
	end
			
	-- need 2 anchors for some reason, ask the author of TinyDPS why -_-"
	tdpsPosition = {x = 0, y = -6}
    tdpsAnchor:SetPoint('BOTTOMLEFT', TukuiMinimapStatsLeft or TukuiReputation or TukuiMinimap, 'BOTTOMLEFT', 0, -6)
			
	tdpsFrame:SetTemplate("Transparent")
	tdpsFrame:CreateShadow("Default")
	
	self:UnregisterEvent('ADDON_LOADED')
	
	if tdpsStatusBar then
		tdpsStatusBar:SetBackdrop({bgFile = C["media"].normTex, edgeFile = C["media"].blank, tile = false, tileSize = 1, edgeSize = 1, insets = { left = 0, right = 0, top = 0, bottom = 0}})
		tdpsStatusBar:SetStatusBarTexture(C["media"].normTex)
	end
	
	self:UnregisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
end)